JavaScript错误处理机制全面分析讲解

目录

1. Error 实例

JavaScript在运行错误时会抛出一个错误,JS提供了Error构造函数,所有抛出的错误都是这个构造函数的实例

const err = new Error('代码出错了');
err.message; // 代码出错了

上面的Error接受了一个message参数,Error构造函数还有另外两个参数name和stack

message 错误提示信息 name 错误名称 stack 错误的调用栈
const err = new Error('代码出错了');
err.name; // 'Error'
err.stack; //'Error: 出错了\n    at <anonymous>:1:5'

2. 原生错误类型

除了基础的Error错误类型,JavaScript还内置了六种原始的错误类型

ReferenceError 引用错误 SyntaxError 语法错误 TypeError 类型错误 RangeError 范围错误 URIError URI方法执行错误 EvalError eval函数执行错误

2.1 ReferenceError

使用一个不存在的变量时会抛出Reference Error

test; 
//Uncaught ReferenceError: assd is not defined at <anonymous>:1:1

另一种触发的场景是将一个值分配给无法分配的对象,比如对函数的运行结果赋值

console.log() = 1
// Uncaught ReferenceError: Invalid left-hand side in assignment

2.2 SyntaxError

当JS解析代码发生错误时会抛出SyntaxError错误

const 1a;
Uncaught SyntaxError: Invalid or unexpected token
5 = 6;
Uncaught SyntaxError: Invalid left-hand side in assignment

2.3 TypeError

放变量或者参数不是预期类型的时候会出现TypeError错误,比如对非函数类型使用new,或者对非函数类型使用圆括号运算

let a; 
a(); 
//VM7449:1 Uncaught TypeError: b is not a function at <anonymous>:1:1

2.4 RangeError

当数值超出预期范围的时候会出现RangeError,主要情况有几种,一是数组长度为负数,二是Number对象的方法接收的参数超出范围,以及函数堆栈超出最大值

const arr = new Array(-5);
//VM7833:1 Uncaught RangeError: Invalid array lengthat <anonymous>:1:13
function foo(){
  foo();
};
foo();
//Uncaught RangeError: Maximum call stack size exceeded

2.5 URIError

URI方法执行错误时会出现URIError错误,例如URIError接收非预期的参数

decodeURI('%');
//VM8142:1 Uncaught URIError: URI malformedat decodeURI (<anonymous>)at <anonymous>:1:1

2.6 evalError

eval函数执行错误时会抛出EvalError,该错误类型以及不再被使用了,知识为了保证与以前代码兼容才保留

3. 自定义错误类型

除了JS提供的7种原生的错误类型,还可以通过继承Error自定义错误类型

funtion CustomError(message){
  this.message = message;
  this.name = 'CustomError';
};
CustomError.prototype = new Error();
CustomError.prototype.construct = CustomError;
throw new CustomError('这是一个自定义错误');
//CustomError {message: '这是一个自定义错误', name: 'CustomError'};

4. throw

在使用thorw抛出错误的时候,代码执行会在在throw处终止,thorw以下的代码将不再执行

throw new Error('出错了');
console.log('该行代码不会执行');

实际上throw不仅能抛出Error实例,还能抛出任意类型的数据,对javaScript引擎来说只要遇上throw代码就停止执行

thorw '23';
console.log('该行代码不会执行');
throw true;
throw {};
throw [];
throw 20;

throw方法有两种写法,可以加上圆括号和省略圆括号

throw new Error('出错了');
throw (new Error('出错了'));

5. try…catch

使用throw的时候会阻碍后续代码的执行,使用费try…catch包裹throw语句就不会影响后续代码的执行了,catch用于错误的捕获,代码发生错误的时候执行。

    try {
      throw new Error('出错了');
    } catch (e) {
      console.error(e)
    };
    console.log('后续代码继续执行'); //后续代码继续执行

6. finally

不管是否发生错误finally语句都会执行

    try {
      throw new Error('出错了');
    } catch (e) {
      console.log('catch')
    }finally{
       console.log('finally');
    }

总结

JS内置了六种内错误类型: SyntaxError、ReferenceError、TypeError、RangeError、URIError、EvalError

原文地址:https://blog.csdn.net/qq_44621394/article/details/127036492
42人参与, 0条评论 登录后显示评论回复

你需要登录后才能评论 登录/ 注册